"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Highlight;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var escapeHtml = function escapeHtml(unsafe) {
  return unsafe.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#039;');
};

var addHighlight = function addHighlight(query, text) {
  var className = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  if (!text) return '';
  return escapeHtml(text).replace(new RegExp(query, 'gi'), function (match) {
    return "<span class=\"".concat(className, "\">").concat(match, "</span>");
  });
};

function Highlight(_ref) {
  var query = _ref.query,
      text = _ref.text,
      _ref$classes = _ref.classes,
      classes = _ref$classes === void 0 ? {} : _ref$classes,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["query", "text", "classes"]);
  return /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({}, props, {
    dangerouslySetInnerHTML: {
      __html: addHighlight(query, text, classes.highlight)
    }
  }));
}
//# sourceMappingURL=Highlight.js.map